accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView

from accounts.views import signup


urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path

from projects.views import (
    ProjectCreateView,
    ProjectListView,
    ProjectDetailView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tasks/urls.py
from django.urls import path

from tasks.views import (
    TaskCreateView,
    TaskListView,
    TaskUpdateView,
)

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("list_projects")),
        name="home",
    ),
]

projects/models.py
from django.db import models

# Create your models here.
class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField("auth.User", related_name="projects")

    def __str__(self):
        return str(self.name)

tasks/models.py
from django.db import models


# Create your models here.
class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project", related_name="tasks", on_delete=models.CASCADE
    )
    assignee = models.ForeignKey(
        "auth.User",
        related_name="tasks",
        null=True,
        on_delete=models.SET_NULL,
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST.get("username")
            password = request.POST.get("password")
            user = User.objects.create_user(
                username=username,
                password=password,
            )
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm()
    context = {
        "form": form,
    }
    return render(request, "registration/signup.html", context)

projects/views.py
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.contrib.auth.mixins import LoginRequiredMixin
from projects.models import Project


# Create your views here.


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/create.html"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse_lazy("show_project", args=[self.object.id])

tasks/views.py
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin
from tasks.models import Task

# Create your views here.
# add login


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/create.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def get_success_url(self):
        print(self.object.project)
        return reverse_lazy("show_project", args=[self.object.project.id])


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    template_name = "tasks/update.html"
    fields = ["is_completed"]

    def get_success_url(self):
        return reverse_lazy("show_my_tasks")

projects/templates/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Tracker</title>
    </head>
    <body>
        <header>
            <nav>
                <ul class="navigation">
                    {% if user.is_authenticated %}
                        <li class="nav-item">
                            <a href="{% url 'show_my_tasks' %}">My tasks</a>
                        </li>
                        <li class="nav-item">
                            <a href="{% url 'list_projects' %}">My projects</a>
                        </li>
                        <li class="nav-item">
                            <a href="{% url 'logout' %}">Logout</a>
                        </li>
                    {% else %}
                        <li class="nav-item">
                            <a href="{% url 'login' %}">Login</a>
                        </li>
                        <li class="nav-item">
                            <a href="{% url 'signup' %}">Signup</a>
                        </li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        {% block content %}
        {% endblock content %}
    </body>
</html>

projects/templates/projects/create.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new project</h1>
            <form method="post">
                {% csrf_token %}
                {{form.as_p }}
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}

projects/templates/projects/detail.html
{% extends 'base.html' %}
{% load markdownify %}

{% block content %}
    <main>
        <h1>{{ project.name }}</h1>
        {{ project.description|markdownify }}
        <h2>Tasks</h2>
        <p>
            <a href="{% url 'create_task' %}">Create a new task</a>
        </p>
        {% if project.tasks.all|length != 0 %}
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Assignee</th>
                        <th>Start date</th>
                        <th>Due date</th>
                        <th>Is completed</th>
                    </tr>
                </thead>
                <tbody>
                    {% for task in project.tasks.all %}
                        <tr>
                            <td>{{ task.name }}</td>
                            <td>{{ task.assignee }}</td>
                            <td>{{ task.start_date }}</td>
                            <td>{{ task.due_date }}</td>
                            {% if task.is_completed == True %}
                                <td>yes</td>
                            {% else %}
                                <td>no</td>
                            {% endif %}
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        {% else %}
            <p>This project has no tasks</p>
        {% endif %}
    </main>
{% endblock content %}

projects/templates/projects/list.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>My Projects</h1>
            <a href="{% url 'create_project' %}">Create a new project</a>
            {% if project_list|length == 0 %}
                <p>You are not assigned to any projects</p>
            {% else %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Number of tasks</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for project in project_list %}
                            <tr>
                                <td>
                                    <a href="{% url 'show_project' project.id %}">
                                        {{ project.name }}
                                    </a>
                                </td>
                                <td>{{ project.tasks.all|length }}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% endif %}
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/create.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>Create a new task</h1>
            <form method="post">
                {{ form.as_p }}
                {% csrf_token %}
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/list.html
{% extends 'base.html' %}

{% block content %}
    <main>
        <div>
            <h1>My Tasks</h1>
            {% if task_list|length == 0 %}
                <p>You have no tasks</p>
            {% else %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Start date</th>
                            <th>End date</th>
                            <th>Is completed</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in task_list %}
                            <tr>
                                <td>{{ task.name }}</td>
                                <td>{{ task.start_date }}</td>
                                <td>{{ task.due_date }}</td>
                                {% if task.is_completed == True %}
                                    <td>Done</td>
                                {% else %}
                                    <td>
                                        <form method="post" action="{% url 'complete_task' task.id %}">
                                            {% csrf_token %}
                                            <input type="hidden" name="is_completed" value="True">
                                            <button>Complete</button>
                                        </form>
                                    </td>
                                {% endif %}
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% endif %}
        </div>
    </main>
{% endblock content %}